Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_statistics_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_statistics_deallocation.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_statistics_deallocation.cpp	(revision 81)
@@ -0,0 +1,41 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/include/Prediction_unit_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace prediction_unit_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Prediction_unit_Glue::statistics_deallocation"
+  void Prediction_unit_Glue::statistics_deallocation (void)
+  {
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"Begin");
+
+    log_printf(INFO,Prediction_unit_Glue,FUNCTION,"Generate Statistics file");
+    
+    delete _stat;
+    
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"End");
+  };
+
+}; // end namespace prediction_unit_glue
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_transition.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_transition.cpp	(revision 81)
@@ -0,0 +1,50 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/include/Prediction_unit_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace prediction_unit_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Prediction_unit_Glue::transition"
+  void Prediction_unit_Glue::transition (void)
+  {
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"Begin");
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	reg_PREDICT_PRIORITY = 0;
+      }
+    else
+      {
+	// Round robin priority
+	reg_PREDICT_PRIORITY = (reg_PREDICT_PRIORITY+_param->_nb_inst_predict)%_param->_nb_context;
+      }
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"End");
+  };
+
+}; // end namespace prediction_unit_glue
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl.cpp	(revision 81)
@@ -0,0 +1,50 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/include/Prediction_unit_Glue.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace prediction_unit_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Prediction_unit_Glue::vhdl"
+  void Prediction_unit_Glue::vhdl (void)
+  {
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"Begin");
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"End");
+  };
+
+}; // end namespace prediction_unit_glue
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl_body.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl_body.cpp	(revision 81)
@@ -0,0 +1,37 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/include/Prediction_unit_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace prediction_unit_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Prediction_unit_Glue::vhdl_body"
+  void Prediction_unit_Glue::vhdl_body (Vhdl * & vhdl)
+  {
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"Begin");
+    vhdl->set_body ("");
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"End");
+  };
+
+}; // end namespace prediction_unit_glue
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl_declaration.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_vhdl_declaration.cpp	(revision 81)
@@ -0,0 +1,36 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/include/Prediction_unit_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace prediction_unit_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Prediction_unit_Glue::vhdl_declaration"
+  void Prediction_unit_Glue::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"Begin");
+    log_printf(FUNC,Prediction_unit_Glue,FUNCTION,"End");
+  };
+
+}; // end namespace prediction_unit_glue
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/SelfTest/config_mono_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/SelfTest/config_mono_context.cfg	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/SelfTest/config_mono_context.cfg	(revision 81)
@@ -1,5 +1,5 @@
 Return_Address_Stack
 1	1	+1	# nb_context     
-2	2	*2	# size_queue     [0]
+2	4	*2	# size_queue     [0]
 32	32	*2	# size_address   
 1	1	+1	# nb_inst_predict
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/SelfTest/src/test.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/SelfTest/src/test.cpp	(revision 81)
@@ -11,6 +11,6 @@
 #include "Behavioural/include/Allocation.h"
 
-#define NB_ITERATION  1024
-#define CYCLE_MAX     (128*NB_ITERATION)
+#define NB_ITERATION  16
+#define CYCLE_MAX     (1024*NB_ITERATION)
 
 #define LABEL(str...)							\
@@ -21,23 +21,21 @@
   } while(0)
 
-#define SC_START(cycle_offset)                                                       \
-  do									             \
-    {									             \
-      /*cout << "SC_START (begin)" << endl;*/				             \
-									             \
-      uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time());          \
-      if (cycle_offset != 0)						             \
-	{								             \
-	  cout << "##########[ cycle "<< cycle_current+cycle_offset << " ]" << endl; \
-	}								             \
-									             \
-      if (cycle_current > CYCLE_MAX)					             \
-	{								             \
-	  TEST_KO("Maximal cycles Reached");				             \
-	}								             \
-									             \
-      sc_start(cycle_offset);						             \
-									             \
-      /*cout << "SC_START (end  )" << endl;*/				             \
+#define SC_START(cycle_offset)						\
+  do									\
+    {									\
+      uint32_t cycle_current = static_cast<uint32_t>(sc_simulation_time()); \
+      if (cycle_offset != 0)						\
+	{								\
+	  cout << "##########[ cycle "<< cycle_current+cycle_offset << " ]"; \
+	  cout << " (" << __LINE__ << ")" << endl;			\
+	}								\
+      									\
+      if (cycle_current > CYCLE_MAX)					\
+	{								\
+	  TEST_KO("Maximal cycles Reached");				\
+	}								\
+      									\
+      sc_start(cycle_offset);						\
+      									\
     } while(0)
 
@@ -90,4 +88,5 @@
   ALLOC1_SC_SIGNAL( in_UPDATE_ADDRESS        ," in_UPDATE_ADDRESS        ",Taddress_t,_param->_nb_inst_update );
   ALLOC1_SC_SIGNAL( in_UPDATE_MISS_PREDICTION," in_UPDATE_MISS_PREDICTION",Tcontrol_t,_param->_nb_inst_update );
+  ALLOC1_SC_SIGNAL( in_UPDATE_PREDICTION_IFETCH," in_UPDATE_PREDICTION_IFETCH",Tcontrol_t,_param->_nb_inst_update );
   
   /********************************************************
@@ -127,4 +126,5 @@
   INSTANCE1_SC_SIGNAL(_Return_Address_Stack, in_UPDATE_ADDRESS        ,_param->_nb_inst_update );
   INSTANCE1_SC_SIGNAL(_Return_Address_Stack, in_UPDATE_MISS_PREDICTION,_param->_nb_inst_update );
+  INSTANCE1_SC_SIGNAL(_Return_Address_Stack, in_UPDATE_PREDICTION_IFETCH,_param->_nb_inst_update );
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
@@ -157,5 +157,276 @@
       LABEL("Iteration %d",iteration);
 
-      SC_START(1);
+      if (1)
+	{
+	uint32_t port = rand()%_param->_nb_inst_predict;
+
+	LABEL("PREDICT - PUSH");
+	
+	in_PREDICT_VAL  [port]->write(1);
+	in_PREDICT_PUSH [port]->write(1);
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j<_param->_size_queue[i]; j++)
+	    {
+	      in_PREDICT_CONTEXT_ID   [port]->write(i);
+	      in_PREDICT_ADDRESS_PUSH [port]->write(0xdeadbeef+j);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_PREDICT_ACK  [port]->read(), 1);
+	      TEST(Tptr_t    , out_PREDICT_INDEX[port]->read(),(j+1)%_param->_size_queue[i]);
+	      
+	      SC_START(1);
+	      
+	    }
+	in_PREDICT_VAL [port]->write(0);
+	
+	SC_START(1);
+	
+	in_PREDICT_VAL  [port]->write(1);
+	in_PREDICT_PUSH [port]->write(1);
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j<_param->_size_queue[i]; j++)
+	    {
+	      in_PREDICT_CONTEXT_ID   [port]->write(i);
+	      in_PREDICT_ADDRESS_PUSH [port]->write(0x21071981+j);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_PREDICT_ACK        [port]->read(), 1);
+	      TEST(Tptr_t    , out_PREDICT_INDEX      [port]->read(),(j+1)%_param->_size_queue[i]);
+	      TEST(Taddress_t, out_PREDICT_ADDRESS_POP[port]->read(),0xdeadbeef+j);
+	      
+	      SC_START(1);
+	    }
+	in_PREDICT_VAL [port]->write(0);
+	
+	LABEL("PREDICT - POP");
+	
+	in_PREDICT_VAL  [port]->write(1);
+	in_PREDICT_PUSH [port]->write(0);
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j< _param->_size_queue[i]; j++)
+	    {
+	      in_PREDICT_CONTEXT_ID   [port]->write(i);
+	      in_PREDICT_ADDRESS_PUSH [port]->write(0xbabedead);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_PREDICT_ACK        [port]->read(), 1);
+	      TEST(Tcontrol_t, out_PREDICT_HIT        [port]->read(), 1);
+	      uint32_t k=(_param->_size_queue[i]-j)%_param->_size_queue[i];
+	      TEST(Tptr_t    , out_PREDICT_INDEX      [port]->read(), k);
+	      TEST(Taddress_t, out_PREDICT_ADDRESS_POP[port]->read(),(0x21071981+((k==0)?(_param->_size_queue[i]-1):(k-1))));
+	      
+	      SC_START(1);
+	    }
+	in_PREDICT_VAL [port]->write(0);
+	}
+
+      // Now, the stack is empty
+
+      if (1)
+	{
+	uint32_t port1 = rand()%_param->_nb_inst_decod;
+	uint32_t port2 = rand()%_param->_nb_inst_predict;
+
+	LABEL("DECOD - without predict");
+	
+	LABEL("DECOD - PUSH");  
+	
+	in_DECOD_VAL             [port1]->write(1);
+	in_DECOD_PUSH            [port1]->write(1);
+	in_DECOD_MISS_PREDICTION [port1]->write(0);
+	
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j<_param->_size_queue[i]; j++)
+	    {
+	      in_DECOD_CONTEXT_ID   [port1]->write(i);
+	      in_DECOD_ADDRESS_PUSH [port1]->write(0xbeefcaca+j);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_DECOD_ACK  [port1]->read(), 1);
+	      TEST(Tptr_t    , out_DECOD_INDEX[port1]->read(),(j+1)%_param->_size_queue[i]);
+	      
+	      SC_START(1);
+	      
+	    }
+	in_DECOD_VAL [port1]->write(0);
+	
+	SC_START(1);
+	
+	in_DECOD_VAL  [port1]->write(1);
+	in_DECOD_PUSH [port1]->write(1);
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j<_param->_size_queue[i]; j++)
+	    {
+	      in_DECOD_CONTEXT_ID   [port1]->write(i);
+	      in_DECOD_ADDRESS_PUSH [port1]->write(0x21071981+j);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_DECOD_ACK        [port1]->read(), 1);
+	      TEST(Tptr_t    , out_DECOD_INDEX      [port1]->read(),(j+1)%_param->_size_queue[i]);
+	      TEST(Taddress_t, out_DECOD_ADDRESS_POP[port1]->read(),0xbeefcaca+j);
+	      
+	      SC_START(1);
+	    }
+	in_DECOD_VAL [port1]->write(0);
+	
+	LABEL("DECOD - POP");
+	
+	in_DECOD_VAL  [port1]->write(1);
+	in_DECOD_PUSH [port1]->write(0);
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j< _param->_size_queue[i]; j++)
+	    {
+	      in_DECOD_CONTEXT_ID   [port1]->write(i);
+	      in_DECOD_ADDRESS_PUSH [port1]->write(0xbabedead);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_DECOD_ACK        [port1]->read(), 1);
+	      TEST(Tcontrol_t, out_DECOD_HIT        [port1]->read(), 1);
+	      uint32_t k=(_param->_size_queue[i]-j)%_param->_size_queue[i];
+	      TEST(Tptr_t    , out_DECOD_INDEX      [port1]->read(), k);
+	      TEST(Taddress_t, out_DECOD_ADDRESS_POP[port1]->read(),(0x21071981+((k==0)?(_param->_size_queue[i]-1):(k-1))));
+	      
+	      SC_START(1);
+	    }
+	in_DECOD_VAL [port1]->write(0);
+
+	LABEL("DECOD - with predict");
+	
+	LABEL("DECOD - PUSH (size_queue/2)");  
+	
+	in_DECOD_VAL             [port1]->write(1);
+	in_DECOD_PUSH            [port1]->write(1);
+	in_DECOD_MISS_PREDICTION [port1]->write(1);
+	
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j<_param->_size_queue[i]/2;j++)
+	    {
+	      in_DECOD_CONTEXT_ID   [port1]->write(i);
+	      in_DECOD_ADDRESS_PUSH [port1]->write(0x01234567+j);
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_DECOD_ACK  [port1]->read(), 1);
+	      TEST(Tptr_t    , out_DECOD_INDEX[port1]->read(),(j+1)%_param->_size_queue[i]);
+	      
+	      SC_START(1);
+	      
+	    }
+	in_DECOD_VAL [port1]->write(0);
+
+	LABEL("PREDICT - PUSH (size_queue/2)");  
+	
+	in_PREDICT_VAL             [port2]->write(1);
+	in_PREDICT_PUSH            [port2]->write(1);
+	
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  for (uint32_t j=0; j<_param->_size_queue[i]/2;j++)
+	    {
+	      in_PREDICT_CONTEXT_ID   [port2]->write(i);
+	      in_PREDICT_ADDRESS_PUSH [port2]->write((0x89abcdef+j)+(_param->_size_queue[i]/2));
+	      
+	      SC_START(0);
+	      
+	      TEST(Tcontrol_t, out_PREDICT_ACK  [port2]->read(), 1);
+	      TEST(Tptr_t    , out_PREDICT_INDEX[port2]->read(),(j+1+(_param->_size_queue[i]/2))%_param->_size_queue[i]);
+	      
+	      SC_START(1);
+	    }
+
+	in_PREDICT_VAL [port2]->write(0);
+
+	LABEL("PREDICT - POP (size_queue/2)");  
+
+	in_PREDICT_VAL  [port2]->write(1);
+	in_PREDICT_PUSH [port2]->write(0);
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  {
+	    for (uint32_t j=0; j< _param->_size_queue[i]/2; j++)
+	      {
+		in_PREDICT_CONTEXT_ID   [port2]->write(i);
+		in_PREDICT_ADDRESS_PUSH [port2]->write(0xbabedead);
+		
+		SC_START(0);
+		
+		TEST(Tcontrol_t, out_PREDICT_ACK        [port2]->read(), 1);
+		TEST(Tcontrol_t, out_PREDICT_HIT        [port2]->read(), 1);
+		uint32_t k=  (_param->_size_queue[i]-j)%_param->_size_queue[i];
+		TEST(Tptr_t    , out_PREDICT_INDEX      [port2]->read(), k);
+
+		Taddress_t res = (0x89abcdef+((k==0)?(_param->_size_queue[i]-1):(k-1)));
+		LABEL("k      : %d",k);
+		LABEL("res    : %x",res);
+		LABEL("@_pop  : %x",out_PREDICT_ADDRESS_POP[port2]->read());
+
+		TEST(Taddress_t, out_PREDICT_ADDRESS_POP[port2]->read(),res);
+		
+		SC_START(1);
+	      }
+
+	    for (uint32_t j=0; j< _param->_size_queue[i]/2; j++)
+	      {
+		in_PREDICT_CONTEXT_ID   [port2]->write(i);
+		in_PREDICT_ADDRESS_PUSH [port2]->write(0xbabedead);
+		
+		SC_START(0);
+		
+		TEST(Tcontrol_t, out_PREDICT_ACK        [port2]->read(), 1);
+		TEST(Tcontrol_t, out_PREDICT_HIT        [port2]->read(), 1);
+		uint32_t k=(_param->_size_queue[i]/2-j)%_param->_size_queue[i];
+		TEST(Tptr_t    , out_PREDICT_INDEX      [port2]->read(), k);
+
+		Taddress_t res = (0x01234567+((k==0)?(_param->_size_queue[i]/2-1):(k-1)));
+
+		LABEL("k      : %d",k);
+		LABEL("res    : %x",res);
+		LABEL("@_pop  : %x",out_PREDICT_ADDRESS_POP[port2]->read());
+
+		TEST(Taddress_t, out_PREDICT_ADDRESS_POP[port2]->read(),res);
+		
+		SC_START(1);
+	      }
+	  }
+
+	in_PREDICT_VAL [port2]->write(0);
+
+	in_DECOD_VAL  [port1]->write(1);
+	in_DECOD_PUSH [port1]->write(0);
+	in_DECOD_MISS_PREDICTION [port1]->write(0);
+
+	for (uint32_t i=0; i<_param->_nb_context; i++)
+	  {
+	    for (uint32_t j=0; j< _param->_size_queue[i]/2; j++)
+	      {
+		in_DECOD_CONTEXT_ID   [port1]->write(i);
+		in_DECOD_ADDRESS_PUSH [port1]->write(0xbabedead);
+		
+		SC_START(0);
+		
+		TEST(Tcontrol_t, out_DECOD_ACK        [port1]->read(), 1);
+		TEST(Tcontrol_t, out_DECOD_HIT        [port1]->read(), 1);
+		uint32_t k=(_param->_size_queue[i]/2-j)%_param->_size_queue[i];
+		TEST(Tptr_t    , out_DECOD_INDEX      [port1]->read(), k);
+
+		Taddress_t res = (0x01234567+((k==0)?(_param->_size_queue[i]/2-1):(k-1)));
+
+		LABEL("k      : %d",k);
+		LABEL("res    : %x",res);
+		LABEL("@_pop  : %x",out_DECOD_ADDRESS_POP[port1]->read());
+
+		TEST(Taddress_t, out_DECOD_ADDRESS_POP[port1]->read(),res);
+		
+		SC_START(1);
+	      }
+	  }
+
+	in_DECOD_VAL [port1]->write(0);
+
+      }
     }
 
@@ -195,4 +466,6 @@
   delete []  in_UPDATE_INDEX         ;
   delete []  in_UPDATE_ADDRESS       ;
+  delete []  in_UPDATE_MISS_PREDICTION;
+  delete []  in_UPDATE_PREDICTION_IFETCH;
 
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h	(revision 81)
@@ -84,11 +84,12 @@
 
     // ~~~~~[ Interface : "update" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_VAL            ; //[nb_inst_update]
-  public    : SC_OUT(Tcontrol_t)           ** out_UPDATE_ACK            ; //[nb_inst_update]
-  public    : SC_IN (Tcontext_t)           **  in_UPDATE_CONTEXT_ID     ; //[nb_inst_update] 
-  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_PUSH           ; //[nb_inst_update]  1 = push, else pop
-  public    : SC_IN (Taddress_t)           **  in_UPDATE_ADDRESS        ; //[nb_inst_update]
-  public    : SC_IN (Tptr_t    )           **  in_UPDATE_INDEX          ; //[nb_inst_update]
-  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_MISS_PREDICTION; //[nb_inst_update]
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_VAL              ; //[nb_inst_update]
+  public    : SC_OUT(Tcontrol_t)           ** out_UPDATE_ACK              ; //[nb_inst_update]
+  public    : SC_IN (Tcontext_t)           **  in_UPDATE_CONTEXT_ID       ; //[nb_inst_update] 
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_PUSH             ; //[nb_inst_update]  1 = push, else pop
+  public    : SC_IN (Taddress_t)           **  in_UPDATE_ADDRESS          ; //[nb_inst_update]
+  public    : SC_IN (Tptr_t    )           **  in_UPDATE_INDEX            ; //[nb_inst_update]
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_MISS_PREDICTION  ; //[nb_inst_update]
+  public    : SC_IN (Tcontrol_t)           **  in_UPDATE_PREDICTION_IFETCH; //[nb_inst_update] // prediction only ifetch
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -98,8 +99,8 @@
   private   : Tptr_t                        * reg_TOP           ; //[nb_context]
   private   : Tptr_t                        * reg_BOTTOM        ; //[nb_context]
-  private   : Tcontrol_t                    * reg_EMPTY         ; //[nb_context]
+  private   : Tptr_t                        * reg_NB_ELT        ; //[nb_context]
   private   : Tptr_t                        * reg_PREDICT_TOP   ; //[nb_context]
   private   : Tptr_t                        * reg_PREDICT_BOTTOM; //[nb_context]
-  private   : Tcontrol_t                    * reg_PREDICT_EMPTY ; //[nb_context]
+  private   : Tptr_t                        * reg_PREDICT_NB_ELT; //[nb_context]
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -143,5 +144,5 @@
   public  : void        transition                (void);
   public  : void        genMealy_predict          (void);
-//   public  : void        genMealy_decod            (void);
+  public  : void        genMealy_decod            (void);
 //   public  : void        genMealy_update           (void);
 #endif					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack.cpp	(revision 81)
@@ -94,4 +94,34 @@
 # endif    
 
+	log_printf(INFO,Return_Address_Stack,FUNCTION,"Method - genMealy_decod");
+
+	SC_METHOD (genMealy_decod);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // use internal registers
+	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	  {
+	    if (_param->_have_port_context_id)
+	    sensitive << (*( in_DECOD_CONTEXT_ID [i])); 
+	    sensitive << (*( in_DECOD_PUSH       [i]));
+	  }
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+	  {
+	    if (_param->_have_port_context_id)
+	    (*(out_DECOD_HIT         [i])) (*( in_DECOD_CONTEXT_ID [i]));
+	    (*(out_DECOD_HIT         [i])) (*( in_DECOD_PUSH       [i]));
+
+	    if (_param->_have_port_context_id)
+	    (*(out_DECOD_ADDRESS_POP [i])) (*( in_DECOD_CONTEXT_ID [i]));
+	    (*(out_DECOD_ADDRESS_POP [i])) (*( in_DECOD_PUSH       [i]));
+
+	    if (_param->_have_port_context_id)
+	    (*(out_DECOD_INDEX       [i])) (*( in_DECOD_CONTEXT_ID [i]));
+	    (*(out_DECOD_INDEX       [i])) (*( in_DECOD_PUSH       [i]));
+	  }
+# endif
+
 	log_printf(INFO,Return_Address_Stack,FUNCTION,"Method - genMealy_predict");
 
@@ -122,5 +152,5 @@
 	    (*(out_PREDICT_INDEX       [i])) (*( in_PREDICT_PUSH       [i]));
 	  }
-# endif    
+# endif
 #endif
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_allocation.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_allocation.cpp	(revision 81)
@@ -96,4 +96,5 @@
       ALLOC1_SIGNAL_IN ( in_UPDATE_INDEX          ,"index"          ,Tptr_t    ,_param->_size_index);
       ALLOC1_SIGNAL_IN ( in_UPDATE_MISS_PREDICTION,"miss_prediction",Tcontrol_t,1);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_PREDICTION_IFETCH,"prediction_ifetch",Tcontrol_t,1);
     }
 
@@ -106,9 +107,9 @@
     reg_TOP              = new Tptr_t     [_param->_nb_context];
     reg_BOTTOM           = new Tptr_t     [_param->_nb_context];
-    reg_EMPTY            = new Tcontrol_t [_param->_nb_context];
+    reg_NB_ELT           = new Tptr_t     [_param->_nb_context];
 
     reg_PREDICT_TOP      = new Tptr_t     [_param->_nb_context];
     reg_PREDICT_BOTTOM   = new Tptr_t     [_param->_nb_context];
-    reg_PREDICT_EMPTY    = new Tcontrol_t [_param->_nb_context];
+    reg_PREDICT_NB_ELT   = new Tptr_t     [_param->_nb_context];
 
     internal_PREDICT_ACK = new Tcontrol_t [_param->_nb_inst_predict];
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_deallocation.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_deallocation.cpp	(revision 81)
@@ -1,3 +1,3 @@
-*/*
+/*
  * $Id$
  *
@@ -54,4 +54,6 @@
 	delete []  in_UPDATE_INDEX         ;
 	delete []  in_UPDATE_ADDRESS       ;
+	delete []  in_UPDATE_MISS_PREDICTION;
+	delete []  in_UPDATE_PREDICTION_IFETCH;
       }
 
@@ -61,8 +63,8 @@
     delete [] reg_TOP;
     delete [] reg_BOTTOM;
-    delete [] reg_EMPTY;
+    delete [] reg_NB_ELT;
     delete [] reg_PREDICT_TOP;
     delete [] reg_PREDICT_BOTTOM;
-    delete [] reg_PREDICT_EMPTY;
+    delete [] reg_PREDICT_NB_ELT;
     
     delete [] internal_PREDICT_ACK;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_genMealy_decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_genMealy_decod.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_genMealy_decod.cpp	(revision 81)
@@ -48,5 +48,6 @@
 	// if push : value is hit
 	// if pop  : val and not miss
-	internal_DECOD_HIT [i] = (push or (reg_stack[context][top]._val and not reg_stack[context][top]._miss));
+	//   when the predictor : if hit = 0, wait (is not accurate)
+	internal_DECOD_HIT [i] = (push or (reg_stack[context][top]._val and not reg_stack[context][top]._miss and (reg_NB_ELT[context]>0)));
 	PORT_WRITE(out_DECOD_HIT         [i], internal_DECOD_HIT [i]);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_genMealy_predict.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_genMealy_predict.cpp	(revision 81)
@@ -48,5 +48,5 @@
 	// if push : value is hit
 	// if pop  : val and not miss
-	internal_PREDICT_HIT [i] = (push or (reg_stack[context][top]._val and not reg_stack[context][top]._miss));
+	internal_PREDICT_HIT [i] = (push or (reg_stack[context][top]._val and not reg_stack[context][top]._miss and (reg_PREDICT_NB_ELT[context]>0)));
 	PORT_WRITE(out_PREDICT_HIT         [i], internal_PREDICT_HIT [i]);
 
